using System;
using System.Data;
using System.Data.SqlClient;

class DataAdapterDemo {
	SqlConnection dbConnection = new SqlConnection();
	SqlDataAdapter dbAdapter = new SqlDataAdapter();
	DataSet ds = new DataSet();
	DataTable dt;

	DataAdapterDemo() {
		dbConnection.ConnectionString = @"Data Source=(local)\SQLEXPRESS;" +
			@"AttachDbFilename=E:\Data\NORTHWND.MDF;" +
			"Integrated Security=True;User Instance=True";
		dbAdapter.SelectCommand = new SqlCommand("SELECT EmployeeID,FirstName,LastName FROM Employees", dbConnection);
		//dbAdapter.MissingSchemaAction = MissingSchemaAction.AddWithKey;

		try	{
			dbConnection.Open(); // Vermeidet zweimaliges ffnen und Schlieen durch Fill() und FillSchema()
			dbAdapter.Fill(ds, "Employees");
			dt = ds.Tables["Employees"];
			//Console.Write("Name ="+ds.Tables[0].TableName);
			dbAdapter.FillSchema(dt, SchemaType.Source);
		} finally {
			dbConnection.Close();
		}
		SqlCommandBuilder cb = new SqlCommandBuilder(dbAdapter);
	}

	void PrintData() {
		for (int i = 0; i < dt.Rows.Count; i++)	{
			for (int j = 0; j < dt.Columns.Count; j++)
				Console.Write("{0,15}", dt.Rows[i][j]);
			Console.WriteLine();
		}
	}

	void AddData() {
		DataRow dr = dt.NewRow();
		dr["FirstName"] = "first";
		dr["LastName"] = "last";
		dt.Rows.Add(dr);
	}

	void ChangeData() {
		DataRow dr = dt.NewRow();
		foreach (DataRow row in dt.Rows)
			if (row["LastName"].ToString() == "last")
				row["LastName"] = "laster";
	}

	void UpdateData() {
		dbAdapter.Update(ds, "Employees");
	}

	static void Main(){
		DataAdapterDemo updateDemo = new DataAdapterDemo();
		updateDemo.PrintData();
		Console.ReadLine();

		updateDemo.AddData();
		updateDemo.PrintData();
		Console.ReadLine();

		updateDemo.ChangeData();
		updateDemo.PrintData();
		updateDemo.UpdateData();
		Console.ReadLine();
	}
}