﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Eddie {
	/// <summary>
	/// Interaktionslogik für SearchDialog.xaml
	/// </summary>
	public partial class SearchDialog : Window {

		public event EventHandler FindNext;

		public string SearchText {
			get { return tbSearchText.Text; }
			set { tbSearchText.Text = value; }
		}

		public SearchDialog() {
			InitializeComponent();
		}

		private void btnCancel_Click(object sender, RoutedEventArgs e) {
			Close();
		}

		private void btnNext_Click(object sender, RoutedEventArgs e) {
			if (tbSearchText.Text.Length > 0 && FindNext != null)
				FindNext(this, EventArgs.Empty);
		}

		private void Window_Loaded(object sender, RoutedEventArgs e) {
			Keyboard.Focus(tbSearchText);
		}
	}
}
