﻿using System;
using NorthwindEF;
using System.Linq;

class Program {
	static void Main() {
		using (NORTHWNDEntities context = new NORTHWNDEntities()) {

			//context.ContextOptions.LazyLoadingEnabled = false;

			// Aus der folgenden Abfrage resultiert eine kollektion mit Objekten von einem anonymen Typ.
			//var custColl = from c in context.Customers
			//           where c.Country == "Germany"
			//           select new { c.CustomerID, c.CompanyName, c.Orders };

			//foreach (var c in custColl) {
			//    Console.WriteLine(c.CustomerID + " " + c.CompanyName);
			//    foreach (var ord in c.Orders)
			//        Console.WriteLine(" " + ord.OrderDate);
			//}

			// Liefert das erste (und einzige) Element aus dem EntitySet Customers mit der CustomerID custID
			String custID = "WANDK";
			Customer cust = null;
			try {
				cust = context.Customers.First<Customer>(c => c.CustomerID == custID);
			} catch {
				Console.WriteLine("CustomerID " + custID + " nicht vorhanden");
				Console.ReadLine();
				return;
			}

			// Zur Demonstration von Lacy Loading
			//Console.WriteLine("Lacy-Loading: " + context.ContextOptions.LazyLoadingEnabled +
			//    "\nAufträge des Kunden: " + cust.Orders.Count);
			//Console.ReadLine();
			//return;

			Console.WriteLine(cust.EntityState + " \t " + cust.CustomerID + " \t " + cust.CompanyName);
			foreach (var ord in cust.Orders)
				Console.WriteLine(" " + ord.OrderDate);

			cust.CompanyName = "Die Wabernde Kuh";

			// Aufträge vor 1998 löschen
			int i = 0;
			int last = cust.Orders.Count - 1;
			while (i <= last) {
				if (DateTime.Compare((DateTime)cust.Orders.ElementAt(i).OrderDate, new DateTime(1998, 1, 1)) < 0) {
					cust.Orders.ElementAt(i).Order_Details.Clear();
					context.DeleteObject(cust.Orders.ElementAt(i));
					last--;
				} else
					i++;
			}

			Console.WriteLine(cust.EntityState + " \t " + cust.CustomerID + " \t " + cust.CompanyName);
			foreach (var ord in cust.Orders)
				Console.WriteLine(" " + ord.OrderDate);

			context.SaveChanges();
			Console.WriteLine("\nDie Änderungen wurden in die Datenbank geschrieben.\n");
			Console.ReadLine();
		}
	}
}