using System;
using System.IO;

public delegate void FileWriteDelegate(String name, byte[] bar);

class AsyncFileWrite {
	static void AsynWrite(String name, byte[] bar) {
		FileStream s = null;
		try {
			s = new FileStream(name, FileMode.Create);
			s.Write(bar, 0, bar.Length);
		} finally {
			s.Close();
		}
	}
	
	static void Main() {
		String name = "demo.bin";
		byte[] arr = new byte[1073741824];

		FileWriteDelegate awd = new FileWriteDelegate(AsynWrite);
		Console.WriteLine("Das asynchrone Schreiben startet.\n");
		IAsyncResult iar = awd.BeginInvoke(name, arr, null, null);

		int i = 0;
		while (!iar.IsCompleted) {
			System.Threading.Thread.Sleep(1000);
			Console.WriteLine("{0} Sek. Zeit zum Erledigen anderer Arbeiten", ++i);
		}

		awd.EndInvoke(iar);
		Console.WriteLine("\nFertig!");
		Console.Read();
	}
}