﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Threading;

namespace DirSize {

	delegate void LabelUpdateDelegate(String s);

	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {

		LabelUpdateDelegate laup;
		Thread worker;
		bool bValToRemove;
		IAsyncResult ar;

		public MainWindow() {
			InitializeComponent();
			laup = new LabelUpdateDelegate(this.UpdateLabel);
		}

		private void Window_Loaded(object sender, RoutedEventArgs e) {
			Keyboard.Focus(eingabe);
		}

		void WorkerMethod(Object dirp) {
			String dir = (String)dirp;
			String strSize = "Unbekannt";
			try {
				DirectoryInfo di = new DirectoryInfo(dir);
				long Size = DirectorySize(di);
				strSize = String.Format("{0,-10:f2}", Size / 1048576.0);
			} catch (ThreadAbortException) {
			} catch (Exception e) {
				MessageBox.Show(e.Message);
				strSize = "Berechnung gescheitert";
			}
			ergebnis.Dispatcher.BeginInvoke(laup, strSize);
		}

		long DirectorySize(DirectoryInfo d) {
			long Size = 0;
			FileInfo[] fis = d.GetFiles();
			foreach (FileInfo fi in fis) {
				Size += fi.Length;
			}
			DirectoryInfo[] dis = d.GetDirectories();
			foreach (DirectoryInfo di in dis) {
				Size += DirectorySize(di);
			}
			return (Size);
		}

		void UpdateLabel(string s) {
			ergebnis.Content = s;
			bValToRemove = true;
			start.IsEnabled = true;
			stop.IsEnabled = false;
		}

		private void start_Click(object sender, RoutedEventArgs e) {
			if (!Directory.Exists(eingabe.Text)) {
				ergebnis.Content = "Ordner exisiert nicht";
				bValToRemove = true;
				return;
			}
			worker = new Thread(new ParameterizedThreadStart(this.WorkerMethod));
			worker.Start(eingabe.Text);
			ergebnis.Content = "Berechnung läuft ...";
			start.IsEnabled = false;
			stop.IsEnabled = true;
		}

		private void stop_Click(object sender, RoutedEventArgs e) {
			worker.Abort();
			ergebnis.Content = "Berechnung gestoppt";
			bValToRemove = true;
			start.IsEnabled = true;
			stop.IsEnabled = false;
		}

		private void eingabe_TextChanged(object sender, TextChangedEventArgs e) {
			if (bValToRemove) {
				ergebnis.Content = "";
				bValToRemove = false;
			}
		}

		private void button3_Click(object sender, RoutedEventArgs e) {
			if (worker != null)
				worker.Abort();
			this.Close();
		}




	}
}
