using System;
using System.Threading;
using System.Threading.Tasks;

class ParallelInvokeVsThread {
	
	static int anz = 1000;
	static CountdownEvent ce;

	static void RandomSum() {
		Random zzg = new Random();
		double erg = 0.0;
		for (int j = 0; j < 100000; j++)
			erg += zzg.NextDouble();
		ce.Signal();
		//Console.WriteLine("RandomSum " + erg + " berechnet von Thread " + Thread.CurrentThread.ManagedThreadId);
	}

	static void RandomSumTP(Object obj) {
		Random zzg = new Random();
		double erg = 0.0;
		for (int j = 0; j < 100000; j++)
			erg += zzg.NextDouble();
		ce.Signal();
	}

	static void Main() {
		Action[] av = new Action[anz];
		for (int i = 0; i < anz; i++)
			av[i] = new Action(RandomSum);

		ce = new CountdownEvent(anz);
		long start = DateTime.Now.Ticks;
		Parallel.Invoke(av);
		Console.WriteLine("Zeitaufwand per Invoke in Sek.: " + (DateTime.Now.Ticks - start) / 1.0e7);

		ce = new CountdownEvent(anz);
		start = DateTime.Now.Ticks;
		for (int i = 0; i < anz; i++)
			(new Thread(RandomSum)).Start();
		ce.Wait();
		Console.WriteLine("Zeitaufwand fr einzelne Threads in Sek.: " + (DateTime.Now.Ticks - start) / 1.0e7);

		ce = new CountdownEvent(anz);
		start = DateTime.Now.Ticks;
		for (int i = 0; i < anz; i++)
			ThreadPool.QueueUserWorkItem(RandomSumTP);
		ce.Wait();
		Console.WriteLine("Zeitaufwand bei Threadpool-Items in Sek.: " + (DateTime.Now.Ticks - start) / 1.0e7);

		Console.ReadLine();
	}
}