using System;
using System.Threading.Tasks;

class TaskContinueWhenAll {
	static int anz = 10000;
	static int sg = 10000;

	static double SampleMean(Object obj) {
		int start = (int) obj;
		Random zzg = new Random(start);
		double erg = 0.0;
		for (int j = 0; j < sg; j++)
			erg += 5.0 + zzg.NextDouble()*10.0;
		return erg/sg;
	}

	static void Summary(Task<double>[] sampleMeanTaskArray) {
		double x;
		double min = Double.MaxValue;
		double max = Double.MinValue;
		int n = sampleMeanTaskArray.Length;
		for (int j = 0; j < n; j++) {
			x = sampleMeanTaskArray[j].Result;
			if (x < min) min = x;
			if (x > max) max = x;
		}
		Console.WriteLine("\nAnzahl = {0,5:d}\nUmfang = {1,5:d}\nmin. Mittel = {2,10:f7}"+
			"\nmax. Mittel = {3,10:f7}\nSpannweite = {4,10:f7}", n, sg, min, max, (max-min));
	}

	static void Main() {
		long start = DateTime.Now.Ticks;
		Task<double>[] sampleMeanTaskArray = new Task<double>[anz];
		for (int i = 0; i < anz; i++)
			sampleMeanTaskArray[i] = Task.Factory.StartNew<double>(SampleMean, i);

		//Action<Task<double>[]> summaryDelegate = new Action<Task<double>[]>(Summary);

		Task summaryTask = Task.Factory.ContinueWhenAll<double>(sampleMeanTaskArray, Summary);

		summaryTask.Wait();
		Console.WriteLine("Zeit im Sek.: " + (DateTime.Now.Ticks - start) / 1.0e7);

		Console.ReadLine();
	}
}