﻿using System;
using System.Windows;
using System.Threading;
using System.Windows.Controls;

delegate void LabelUpdateDelegate(String s);

class ThreadingTimer : Window {
	Label anzeige;
	Timer tim;
	Random zzg = new Random();
	LabelUpdateDelegate laup;

	ThreadingTimer() {
		Height = 120; Width = 400;
		Title = "System.Threading.Timer";

		StackPanel lm = new StackPanel();
		lm.VerticalAlignment = VerticalAlignment.Center;
		Content = lm;
	
		anzeige = new Label();
		anzeige.HorizontalAlignment = System.Windows.HorizontalAlignment.Center;
		lm.Children.Add(anzeige);

		laup = new LabelUpdateDelegate(this.UpdateLabel);
		tim = new Timer(new TimerCallback(this.HintergrundAktion), null, 0, 10000);

		TextBox eingabe = new TextBox();
		eingabe.Width = 180;
		lm.Children.Add(eingabe);
	}

	void HintergrundAktion(object info) {
		double zs = 0;
		for (int i = 0; i < 300000000; i++)
			zs += zzg.Next(100);
		anzeige.Dispatcher.BeginInvoke(laup, zs.ToString());
	}

	void UpdateLabel(String s) {
		anzeige.Content = "Aktuelle Zufallssumme: " + s + " berechnet um " + DateTime.Now.ToLongTimeString();
	}

	[System.STAThreadAttribute]
	static void Main() {
		new Application().Run(new ThreadingTimer());
	}
}