﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace DatenbindungObjekt {
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	
	public partial class MainWindow : Window {

		Personen personen;
		ICollectionView view;
	
		public MainWindow() {
			InitializeComponent();
			personen = (Personen)this.FindResource("Gruppe");
			view = CollectionViewSource.GetDefaultView(personen);
		}

		private void btnSort_Click(object sender, RoutedEventArgs e) {
			//MessageBox.Show(view.ToString());
			if (view.SortDescriptions.Count == 0) {
				view.SortDescriptions.Add(new SortDescription("Name", ListSortDirection.Ascending));
				view.SortDescriptions.Add(new SortDescription("Alter", ListSortDirection.Descending));
			} else
				view.SortDescriptions.Clear();
		}

		private void btnFilter_Click(object sender, RoutedEventArgs e) {
			if( view.Filter == null )
				view.Filter = delegate(object item) {
						return ((Person)item).Alter > 30;
					};
			else
				view.Filter = null;
		}

		private void btnNeu_Click(object sender, RoutedEventArgs e) {
			personen.Add(new Person{Name= "Ortlieb", Alter = 22});
			// Verboten, wenn ItemsSource auf ein Kollektionsobjekt zeigt: 
			// lbPersonen.Items.Add(new Person { Name = "Otto", Alter = 21 });
		}
	}
}
