﻿using System;
using System.ComponentModel;

namespace DatenbindungObjekt {
	class Person : INotifyPropertyChanged {
		public event PropertyChangedEventHandler PropertyChanged;

		protected void ValueChanged(String property) {
			if (PropertyChanged != null ) {
				PropertyChanged(this, new PropertyChangedEventArgs(property));
			}
		}
		
		String name;
		public String Name {
			get { return name; }
			set {
				if (name == value)
					return;
				else {
					name = value;
					ValueChanged("Name");
				}
			}
		}

		int  alter;
		public int Alter {
			get { return alter; }
			set {
				if (alter == value)
					return;
				if (0 <= value  &&  value <= 130) {
					alter = value;
					ValueChanged("Alter");
				}
			}
		}
	}
}
