﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Eddie {
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {

		bool wordWrap = true;
		bool vertSB= false;
		String searchText;
		TextRange tr;

		public MainWindow() {
			InitializeComponent();
		}

		private void miOptions_Click(object sender, RoutedEventArgs e) {
			OptionsDialog od = new OptionsDialog();
			od.Owner = this;
			od.WordWrap = wordWrap;
			od.VertSB = vertSB;
			if (od.ShowDialog() == true) {
				wordWrap = od.WordWrap;
				vertSB = od.VertSB;
			}
			if (wordWrap) {
				eddie.HorizontalScrollBarVisibility = ScrollBarVisibility.Disabled;
				eddie.Document.PageWidth = Double.NaN;
			} else {
				eddie.HorizontalScrollBarVisibility = ScrollBarVisibility.Visible;
				eddie.Document.PageWidth = 5000;
			}
			if (vertSB)
				eddie.VerticalScrollBarVisibility = ScrollBarVisibility.Auto;
			else
				eddie.VerticalScrollBarVisibility = ScrollBarVisibility.Disabled;
		}

		private void miSearch_Click(object sender, RoutedEventArgs e) {
			SearchDialog sd = new SearchDialog();
			sd.FindNext += this.searchDialog_FindNext;
			sd.Closed += this.searchDialog_Closed;
			sd.Owner = this;
			sd.Show();
		}

		private void searchDialog_FindNext(object sender, EventArgs e) {
			searchText = ((SearchDialog)sender).SearchText;
			if (tr != null)
				tr.ApplyPropertyValue(TextElement.BackgroundProperty, new SolidColorBrush(Colors.White));
			FindAndReplaceManager frm = new FindAndReplaceManager(eddie.Document);
			TextPointer tp = eddie.CaretPosition;
			tr = frm.GetTextRangeFromPosition(ref tp, searchText, FindOptions.None);
			if (tr != null) {
				tr.ApplyPropertyValue(TextElement.BackgroundProperty, new SolidColorBrush(Colors.Yellow));
				eddie.CaretPosition = tp;
			} else
				eddie.CaretPosition = tp.DocumentStart;
		}

		private void searchDialog_Closed(object sender, EventArgs ea) {
			if (tr != null)
				tr.ApplyPropertyValue(TextElement.BackgroundProperty, new SolidColorBrush(Colors.White));
		}

		private void Window_Loaded(object sender, RoutedEventArgs e) {
			Keyboard.Focus(eddie);
		}
	}
}
