﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace RssFeedReader {
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {
		public MainWindow() {
			InitializeComponent();
		}

		private void button1_Click(object sender, RoutedEventArgs e) {
			Cursor oldCursor = this.Cursor;
			Cursor = Cursors.Wait;
			try {
				XDocument feed = XDocument.Load(textBox1.Text);
				IEnumerable<RssItem> items;
				items = from item in feed.Descendants("item")
						select new RssItem() {
							Title = item.Element("title").Value,
							Description = item.Element("description").Value,
							Url = item.Element("link").Value
						};
				listBox1.ItemsSource = items;
			} catch (Exception ex) {
				listBox1.ItemsSource = null;
				MessageBox.Show(this, ex.ToString(), ex.Message);
			} finally {
				Cursor = oldCursor;
			}
		}

		private void listBox1_MouseDoubleClick(object sender, MouseButtonEventArgs e) {
			RssItem item = (RssItem)listBox1.SelectedItem;
			// Existiert das SelectedItem? Liefert seine Url-Eigenschaft einen nicht-leeren String?
			if (item != null && !String.IsNullOrEmpty(item.Url))
				try {
					System.Diagnostics.Process.Start(item.Url);
				} catch (Exception ex) {
					MessageBox.Show(this, ex.ToString(), ex.Message);
				}
		}
	}
}
