﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Printing;
using System.Windows.Xps;

namespace DefaultPrintQueueNamespace {
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {
		public MainWindow() {
			InitializeComponent();
		}

		private void buttonPrint_Click(object sender, RoutedEventArgs e) {

			double rand = 96;

			// Voreingestellten Drucker am lokalen Rechner verwenden
			LocalPrintServer localPC = new LocalPrintServer();
			PrintQueue defPrintQueue = localPC.DefaultPrintQueue;
			XpsDocumentWriter xpsDW = PrintQueue.CreateXpsDocumentWriter(defPrintQueue);

			// Druckbereich ermitteln
			PageImageableArea imagArea = defPrintQueue.GetPrintCapabilities().PageImageableArea;

			// FixedPage erstellen
			FixedPage fpage = new FixedPage();
			fpage.Width = imagArea.ExtentWidth;
			fpage.Height = imagArea.ExtentHeight;

			// Canvas für den Seiteninhalt erstellen (erlaubt gemeinsame Transformation)
			Canvas canPage = new Canvas();
			canPage.Background = Brushes.Bisque;
			canPage.Width = fpage.Width - 2 * rand;
			canPage.Height = fpage.Height - 2 * rand;
			canPage.Margin = new Thickness(rand);

			// TextBlock erstellen und auf den Canvas-Container setzen
			TextBlock textBlock = new TextBlock();
			textBlock.Width = canPage.Width;
			textBlock.Height = canPage.Height;
			textBlock.TextWrapping = TextWrapping.Wrap;
			textBlock.Text = textBox.Text;
			textBlock.FontFamily = new FontFamily("Arial");
			textBlock.FontSize = 32;

			// TextBlock auf den Canvas-Container und Container auf die Seite setzen
			canPage.Children.Add(textBlock);
			fpage.Children.Add(canPage);

			// Das Drucken eines FixedDocument-Objekts klappt mit jedem Drucketreiber
			FixedDocument fdoc = new FixedDocument();
			PageContent fpageContent = new PageContent();
			((System.Windows.Markup.IAddChild)fpageContent).AddChild(fpage);
			fdoc.Pages.Add(fpageContent);
			xpsDW.Write(fdoc);
		}
	}
}
