﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Printing;
using System.Windows.Xps;

namespace Paginierung {
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {
		public MainWindow() {
			InitializeComponent();
		}

		private void buttonPrint_Click(object sender, RoutedEventArgs e) {

			// XpsDocumentWriter mit dem angebundenen Drucker erstellen und ggf. abbrechen
			PrintDocumentImageableArea imageableArea = null;
			XpsDocumentWriter writer = PrintQueue.CreateXpsDocumentWriter(ref imageableArea);
			if (writer == null)
				return;

			// Run erstellen
			Run run = new Run(textBox.Text);
			run.FontFamily = new FontFamily("Arial");
			run.FontSize = 16;

			// FlowDocument erstellen mit eineem Paragraph-Block bestehend aus einem Run-Inline erstellen
			FlowDocument flowDoc = new FlowDocument();
			flowDoc.Blocks.Add(new Paragraph(run));
			
			// Verhindert den voreingestellten 2-Spalten-Druck
			flowDoc.ColumnWidth = imageableArea.ExtentWidth;

			// Die Eigenschaft DocumentPaginator ist nur über den Typ IDocumentPaginatorSource nutzbar
			DocumentPaginator paginator = (flowDoc as IDocumentPaginatorSource).DocumentPaginator;
			
			// Druckbereich als PageSize für die paginierung einstellen
			paginator.PageSize = new Size(imageableArea.ExtentWidth, imageableArea.ExtentHeight);

			// FlowDocument mit Paginierung drucken
			writer.Write(paginator);
			//writer.WriteAsync(paginator);
		}
	}
}
