﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Printing;
using System.Windows.Xps;

namespace XpsDocumentWriterNamespace {
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {
		public MainWindow() {
			InitializeComponent();
		}

		private void buttonPrint_Click(object sender, RoutedEventArgs e) {

			double rand = 96;

			// XpsDocumentWriter mit dem angebundenen Drucker erstellen und ggf. abbrechen
			PrintDocumentImageableArea imageableArea = null;
			XpsDocumentWriter fdocWriter = PrintQueue.CreateXpsDocumentWriter(ref imageableArea);
			if (fdocWriter == null)
				return;

			// FixedDocument erstellen
			FixedDocument fdoc = new FixedDocument();

			// PageContent-Objekte in das FixedDocument aufnehmen
			fdoc.Pages.Add(PreparePage(textBox1, imageableArea.MediaSizeWidth, imageableArea.MediaSizeHeight, rand));
			fdoc.Pages.Add(PreparePage(textBox2, imageableArea.MediaSizeWidth, imageableArea.MediaSizeHeight, rand));

			// FixedDocument synchron drucken
			fdocWriter.Write(fdoc);
		}

		PageContent PreparePage(TextBox tb, double width, double height, double rand) {
			FixedPage fpage = new FixedPage();
			fpage.Width = width;
			fpage.Height = height;

			PageContent fpageContent = new PageContent();
			((System.Windows.Markup.IAddChild)fpageContent).AddChild(fpage);

			Canvas canPage = new Canvas();
			canPage.Background = Brushes.Bisque;
			canPage.Width = fpage.Width - 2 * rand;
			canPage.Height = fpage.Height - 2 * rand;
			canPage.Margin = new Thickness(rand);

			TextBlock textBlock1 = new TextBlock();
			textBlock1.Width = canPage.Width;
			textBlock1.Height = canPage.Height;
			textBlock1.TextWrapping = TextWrapping.Wrap;
			textBlock1.Text = tb.Text;
			textBlock1.FontFamily = new FontFamily("Arial");
			textBlock1.FontSize = 32;

			canPage.Children.Add(textBlock1);
			fpage.Children.Add(canPage);

			return fpageContent;
		}
	}
}
